//+------------------------------------------------------------------+
//|                                             Phoenix_5_6_03.mq4   |
//|                                       Copyright  2006, Hendrick |
//|                                                                  |
//| latest update 11 maart 2011                                      |
//| by Tjipke de Vries                                               |
//| added 4/5 digits functions                                       |
//| pre or suffix in preffered currencie doesn't matter anymore      |
//| made it to work on ECN accounts                                  |
//| solution of modify error 1 + error 145                           |
//| Signal 5 is now GMT timesetting                                  |
//| Now automatic micro or not micro account                         |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Hendrick."

#define MAGICMA_A  20050610
#define MAGICMA_B  20060611

#define MAGICMA01  20050612
#define MAGICMA02  20060613
#define MAGICMA03  20060614

extern string     GeneralSettings         = "===== General Settings ============================";
extern int        PhoenixMode             = 3;
extern double     Lots                    = 1;
extern double     MaximumRisk             = 0.05;
extern int        DecreaseFactor          = 0;
extern bool       MM                      = true;
//extern bool       AccountIsMicro          = true;

extern bool       PrefSettings            = true;

extern int        ServerTimezone          = 0;
extern int        CloseAfterHours         = 0;
extern int        BreakEvenAfterPips      = 0;

extern string     Mode1                   = "====== Phoenix Mode 1 (Classic) ==================";
extern int        TakeProfit              = 0;
extern int        StopLoss                = 0;
extern int        TrailingStop            = 0;
extern int        TrailingStep            = 1;

extern string     Mode2                   = "====== Phoenix Mode 2 (Second trade)==============";
extern int        Mode2_OpenTrade_2       = 0;
extern int        Mode2_TakeProfit        = 0;
extern int        Mode2_StopLoss          = 0;
extern bool       Mode2_CloseFirstTrade   = false;
     
extern string     Mode3                   = "====== Phoenix Mode 3 (Three trades at once) =====";
extern int        Mode3_CloseTrade2_3     = 0;
extern int        Mode3_TakeProfit        = 0;
extern int        Mode3_StopLoss          = 0;

extern string     Signal1                 = "====== Signal 1 ===================================";
extern bool       UseSignal1              = true;
extern double     Percent                 = 0;
extern int        EnvelopePeriod          = 0;

extern string     Signal2                 = "====== Signal 2 ==================================";
extern bool       UseSignal2              = true;
extern int        SMAPeriod               = 0;
extern int        SMA2Bars                = 0;

extern string     Signal3                 = "====== Signal 3 ==================================";
extern bool       UseSignal3              = true;
extern int        OSMAFast                = 0;
extern int        OSMASlow                = 0;
extern double     OSMASignal              = 0;

extern string     Signal4                 = "====== Signal 4 ==================================";
extern bool       UseSignal4              = true;
extern int        Fast_Period             = 0;
int        Fast_Price              = 1;   //PRICE_OPEN;
extern int        Slow_Period             = 0;
int        Slow_Price              = 1;   //PRICE_OPEN;
extern double     DVBuySell               = 0;
extern double     DVStayOut               = 0;

extern string     Signal5                 = "====== Signal 5 =================================";
extern bool       UseSignal5              = true;
extern int        TradeFrom1              = 0;
extern int        TradeUntil1             = 24;
extern int        TradeFrom2              = 0;
extern int        TradeUntil2             = 0;
extern int        TradeFrom3              = 0;
extern int        TradeUntil3             = 0;
extern int        TradeFrom4              = 0;
extern int        TradeUntil4             = 0;

double pointvalue;
int    iError,Slippage;
int    NumberOfTries  = 5, //Number of tries to set, close orders;
       RetryTime   = 1;
int    lasttrade = 0;
string filename="",TradeLog;


#include <stderror.mqh>


int init()
{
if (Digits == 4 || Digits == 2) {pointvalue = Point;Slippage=3;}
else if (Digits == 5 || Digits == 3) {pointvalue = 10.0 * Point;Slippage=30;}


//+------------------------------------------------------------------+
//| START Preffered Settings                                         |
//+------------------------------------------------------------------+

if(PrefSettings == true)
{
//   if((Symbol() == "USDJPY") || (Symbol() == "USDJPYm"))
   if(StringFind(Symbol(), "USDJPY", 0)==0)
      {     
  
      Mode2_OpenTrade_2    = 0;
      Mode2_TakeProfit     = 50;
      Mode2_StopLoss       = 60;
      

      Mode3_CloseTrade2_3  = 30;
      Mode3_TakeProfit     = 100;
      Mode3_StopLoss       = 55;
      
      Percent              = 0.0032;
      EnvelopePeriod       = 2;
      
      TakeProfit           = 42;
      StopLoss             = 84;
      TrailingStop         = 0;
      TrailingStep         = 1;
      SMAPeriod            = 2;
      SMA2Bars             = 18;
      OSMAFast             = 5;
      OSMASlow             = 22;
      OSMASignal           = 2;
      
      Fast_Period          = 25;
      Slow_Period          = 15;
      DVBuySell            = 0.0029;
      DVStayOut            = 0.024;
      }

//   if((Symbol() == "EURJPY") || (Symbol() == "EURJPYm"))
   if(StringFind(Symbol(), "EURJPY", 0)==0)
      {
      
      Mode2_OpenTrade_2    = 18;
      Mode2_TakeProfit     = 70;
      Mode2_StopLoss       = 30;
      

      Mode3_CloseTrade2_3  = 55;
      Mode3_TakeProfit     = 70;
      Mode3_StopLoss       = 80;      

      Percent              = 0.007;
      EnvelopePeriod       = 2;
     
      TakeProfit           = 42;
      StopLoss             = 84;
      TrailingStop         = 0;
      TrailingStep         = 1;
      SMAPeriod            = 4;
      SMA2Bars             = 16;
      OSMAFast             = 11;
      OSMASlow             = 20;
      OSMASignal           = 14;
      
      Fast_Period          = 20;
      Slow_Period          = 10;
      DVBuySell            = 0.0078;
      DVStayOut            = 0.026;
      }

//   if((Symbol() == "GBPJPY") || (Symbol() == "GBPJPYm"))
   if(StringFind(Symbol(), "GBPJPY", 0)==0)
      {
      
      Mode2_OpenTrade_2    = 2;
      Mode2_TakeProfit     = 130;
      Mode2_StopLoss       = 80;
      

      Mode3_CloseTrade2_3  = 40;
      Mode3_TakeProfit     = 90;
      Mode3_StopLoss       = 80;      

      
      Percent              = 0.0072;
      EnvelopePeriod       = 2;
      
      TakeProfit           = 42;
      StopLoss             = 84;
      TrailingStop         = 0;
      TrailingStep         = 1;
      SMAPeriod            = 8;
      SMA2Bars             = 12;
      OSMAFast             = 5;
      OSMASlow             = 36;
      OSMASignal           = 10;
      
      Fast_Period          = 17;
      Slow_Period          = 28;
      DVBuySell            = 0.0034;
      DVStayOut            = 0.063;
      }
      
//   if((Symbol() == "USDCHF") || (Symbol() == "USDCHFm"))
   if(StringFind(Symbol(), "USDCHF", 0)==0)
      {
      
      Mode2_OpenTrade_2    = 10;
      Mode2_TakeProfit     = 90;
      Mode2_StopLoss       = 65;
      

      Mode3_CloseTrade2_3  = 85;
      Mode3_TakeProfit     = 130;
      Mode3_StopLoss       = 80;      

      
      Percent              = 0.0056;
      EnvelopePeriod       = 10;
      
      TakeProfit           = 42;
      StopLoss             = 84;
      TrailingStop         = 0;
      TrailingStep         = 1;
      SMAPeriod            = 5;
      SMA2Bars             = 9;
      OSMAFast             = 5;
      OSMASlow             = 12;
      OSMASignal           = 11;
      
      Fast_Period          = 5;
      Slow_Period          = 20;
      DVBuySell            = 0.00022;
      DVStayOut            = 0.0015;
      }
      
//   if((Symbol() == "GBPUSD") || (Symbol() == "GBPUSDm"))
   if(StringFind(Symbol(), "GBPUSD", 0)==0)
      {
      
      Mode2_OpenTrade_2    = 5;
      Mode2_TakeProfit     = 95;
      Mode2_StopLoss       = 90;
      

      Mode3_CloseTrade2_3  = 90;
      Mode3_TakeProfit     = 110;
      Mode3_StopLoss       = 80;      

      
      Percent              = 0.0023;
      EnvelopePeriod       = 6;
      
      TakeProfit           = 42;
      StopLoss             = 84;
      TrailingStop         = 0;
      TrailingStep         = 1;
      SMAPeriod            = 3;
      SMA2Bars             = 14;
      OSMAFast             = 23;
      OSMASlow             = 17;
      OSMASignal           = 15;
      
      Fast_Period          = 25;
      Slow_Period          = 37;
      DVBuySell            = 0.00042;
      DVStayOut            = 0.05;
      }      
      
   if(StringFind(Symbol(), "EURUSD", 0)==0)
      {
      
      Mode2_OpenTrade_2    = 5;
      Mode2_TakeProfit     = 95;
      Mode2_StopLoss       = 90;
      

      Mode3_CloseTrade2_3  = 90;
      Mode3_TakeProfit     = 110;
      Mode3_StopLoss       = 80;      

      
      Percent              = 0.019;
      EnvelopePeriod       = 11;
      
      TakeProfit           = 42;
      StopLoss             = 83;
      TrailingStop         = 0;
      TrailingStep         = 1;
      SMAPeriod            = 6;
      SMA2Bars             = 9;
      OSMAFast             = 13;
      OSMASlow             = 19;
      OSMASignal           = 7;
      
      Fast_Period          = 6;
      Slow_Period          = 37;
      DVBuySell            = 0.00039;
      DVStayOut            = 0.008;
      }            
}
return(0);
}

//+------------------------------------------------------------------+
//| END Preffered Settings                                           |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START EA                                                         |
//+------------------------------------------------------------------+

void start()
   {
    filename=Symbol() + TradeLog + "-" + Month() + "-" + Day() + ".log";
      
   if(Bars<100)
      {
      Print("bars less than 100");
      return(0);  
      }

   subPrintDetails();

   if(PhoenixMode==1)//Phoenix Classic
      {
      CheckOpenTrade();     
      if(CloseAfterHours != 0)  CheckCloseAfterHours();
      if(BreakEvenAfterPips != 0)        CheckBreakEven();
      if(TrailingStop != 0)              CheckTrailingStop();
      }
      
         
   if(PhoenixMode==2)//Phoenix Second Trade
      {
      CheckOpenTrade();     
      if(CloseAfterHours != 0)  CheckCloseAfterHours();
      CheckSecondTrade();
      }

   if(PhoenixMode==3)//Phoenix 123
      {
      CheckOpenTradeMode123();     //checking and opening new orders
      Mode3_MoveSL_Trade_2_3();           
      Mode3_MoveSL_Trade_3();
      if(Mode3_CloseTrade2_3 != 0) CheckCloseTrade23();
      }
      
   } 
     
//+------------------------------------------------------------------+
//| END EA                                                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Calculate open positions                          |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int count=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && (OrderMagicNumber()==MAGICMA_A || OrderMagicNumber()==MAGICMA_B))
        {
         count++;
         if(OrderStopLoss()==0 && OrderTakeProfit()==0)
            {
             if(OrderMagicNumber()==MAGICMA_A)
              {
               if (TakeProfit>0 || StopLoss>0)
               {
                TradeLog = "FirstTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-StopLoss*pointvalue,OrderOpenPrice()+TakeProfit*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+StopLoss*pointvalue,OrderOpenPrice()-TakeProfit*pointvalue);}
               }
              }  
             if(OrderMagicNumber()==MAGICMA_B)
              {
               if (Mode2_TakeProfit>0 || Mode2_StopLoss>0)
               {               
                TradeLog = "Mode2_SecondTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice() - Mode2_StopLoss*pointvalue,OrderOpenPrice() + Mode2_TakeProfit*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice() + Mode2_StopLoss*pointvalue,OrderOpenPrice() - Mode2_TakeProfit*pointvalue);}
               }                           
              }
            }         
        }
     }
     return(count);
  }
//+------------------------------------------------------------------+
//| STOP Function Calculate open positions                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Open Trade                                  |
//+------------------------------------------------------------------+
int CheckOpenTrade()
{      
int Signal=0, err = 0, total = OrdersTotal();

if(CalculateCurrentOrders(Symbol()) < 1)
   {  
   if(CheckSignal(Signal)==1)
      {
      if(OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,0,0,"FirstTrade",MAGICMA_A,0,Red) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
       return(0);
      }
      
   if(CheckSignal(Signal)==2)
      {
      if(OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,0,0,"FirstTrade",MAGICMA_A,0,Blue) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
   }
}
//+------------------------------------------------------------------+
//| END Function Check Open Trade                                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START MODE 3 Function Check Open Trade                           |
//+------------------------------------------------------------------+
int CheckOpenTradeMode123()
{
     
int Signal = 0, err = 0, total = OrdersTotal(), decimalPlaces=1,opentrades;
double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
double minLot  = MarketInfo(Symbol(), MODE_MINLOT );  
if(LotStep<0.1) decimalPlaces=2;
double lots123 = NormalizeDouble(LotsOptimized()/3,decimalPlaces);

//if(lots123 < 0.1 && AccountIsMicro==false) {lots123=0.1;}
//if(lots123 < 0.01 && AccountIsMicro==true) {lots123=0.01;}
if(lots123 < minLot){lots123=minLot;}

opentrades=Mode3CalculateCurrentOrders(Symbol());


if (opentrades<1)      
   {
   if(CheckSignal(Signal)==1)
      {
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,Slippage,0,0,"Mode3_FirstTrade",MAGICMA01,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
           
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,Slippage,0,0,"Mode3_SecondTrade",MAGICMA02,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,Slippage,0,0,"Mode3_ThirdTrade",MAGICMA03,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
      
   if(CheckSignal(Signal)==2)
      {
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,Slippage,0,0,"Mode3_FirstTrade",MAGICMA01,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }      
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,Slippage,0,0,"Mode3_SecondTrade",MAGICMA02,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,Slippage,0,0,"Mode3_ThirdTrade",MAGICMA03,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
   }
}

//+------------------------------------------------------------------+
//| END Function Check Open Trade                                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Second Trade                                |
//+------------------------------------------------------------------+

void CheckSecondTrade()
{
int err = 0, total = OrdersTotal();

for(int z = total - 1; z >= 0; z --)
   {
   if(!OrderSelect( z, SELECT_BY_POS))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() == MAGICMA_B) break;
 
   if(OrderMagicNumber() != MAGICMA_A) continue;

   if(OrderType() == OP_BUY && (Bid-OrderOpenPrice() > pointvalue*Mode2_OpenTrade_2))
      {   
      if(OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,0,0,"Mode2_SecondTrade",MAGICMA_B,0,Blue) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(Mode2_CloseFirstTrade==true) {CloseFirstTrade();}
      return(0);  
      }

   if(OrderType() == OP_SELL && (OrderOpenPrice()-Ask > pointvalue*Mode2_OpenTrade_2))
      {
      if(OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,0,0,"Mode2_SecondTrade",MAGICMA_B,0,Red) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(Mode2_CloseFirstTrade==true) {CloseFirstTrade();}
      return(0);
      }
   }            

}

//+------------------------------------------------------------------+
//| END Function Check Second Trade                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Close Trade 2 And 3                         |
//+------------------------------------------------------------------+
void CheckCloseTrade23()
{

int err = 0, total = OrdersTotal();
bool CloseTrade=false;

for(int z = total - 1; z >= 0; z --)
   {
   if(!OrderSelect( z, SELECT_BY_POS))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() != MAGICMA01) continue;
   
      if((OrderType() == OP_BUY && OrderStopLoss() < OrderOpenPrice())||(OrderType() == OP_SELL && OrderStopLoss() > OrderOpenPrice())){
        if(OrderMagicNumber()==MAGICMA02)
          {               
           TradeLog = "Mode3_SecondTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+Mode3_TakeProfit*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-Mode3_TakeProfit*pointvalue);}
          }                           
        if(OrderMagicNumber()==MAGICMA03)
          {               
           TradeLog = "Mode3_ThirdTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
          }                                 
        }    
   
   if(OrderType() == OP_BUY && (OrderOpenPrice()-Bid > pointvalue * Mode3_CloseTrade2_3)) {CloseTrade=true;}
   if(OrderType() == OP_SELL && (Ask-OrderOpenPrice() > pointvalue * Mode3_CloseTrade2_3)) {CloseTrade=true;}

   if(CloseTrade)
      {
      for(int y = total - 1; y >= 0; y --)
         {
         if(!OrderSelect( y, SELECT_BY_POS))
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }
         if(OrderSymbol() != Symbol()) continue;

         if(OrderMagicNumber() == MAGICMA02 || OrderMagicNumber() == MAGICMA03)
            {
            if(OrderType() == OP_BUY)
               {
               if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet)<0)
                  {
                  err = GetLastError();
                  Print("Error Ordersend(",err,"): ");
                  return(-1);
                  }
               return(0); 
               }
            if(OrderType() == OP_SELL)
               {
               if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet)<0)
                  {      
                  err = GetLastError();
                  Print("Error Ordersend(",err,"): ");
                  return(-1);
                  }
              return(0); 
               }
             }
}
}
}
}


//+------------------------------------------------------------------+
//| END Function Check Close Trade 2 And 3                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Check First Trade Mode3                                    |
//+------------------------------------------------------------------+



void Mode3_MoveSL_Trade_2_3()
{
int err = 0, total = OrdersTotal(), history = HistoryTotal();
bool ChangeStopLoss = false;

for(int z = history - 1; z >= 0; z --)
   {
   if(!OrderSelect( z,SELECT_BY_POS,MODE_HISTORY))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() == MAGICMA03) break;
   
   if(OrderMagicNumber() == MAGICMA02) break;
 
   if(OrderMagicNumber() != MAGICMA01) continue;

   if(OrderProfit() > 0) 
      {
      ChangeStopLoss=true;
      break;
      }
   }


  if(ChangeStopLoss==true)
   {
   for(int y = total - 1; y >= 0; y --)
      {
      if(!OrderSelect(y,SELECT_BY_POS))
         {
         err = GetLastError();
         Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
         continue;
         }

      if(OrderSymbol() != Symbol()) continue;
      if((OrderType() == OP_BUY && ((OrderStopLoss()+1*pointvalue) < OrderOpenPrice()))||(OrderType() == OP_SELL && ((OrderStopLoss()-1*pointvalue) > OrderOpenPrice()))||OrderStopLoss()==0)
       {
        if(OrderMagicNumber()==MAGICMA02)
          {               
           TradeLog = "Mode3_SecondTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+Mode3_TakeProfit*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-Mode3_TakeProfit*pointvalue);}
          }                           
        if(OrderMagicNumber()==MAGICMA03)
          {               
           TradeLog = "Mode3_ThirdTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
          }                                 
        }          
}
}


}
//}
//+------------------------------------------------------------------+
//| END Check First Trade Mode 3                                     |
//+------------------------------------------------------------------+

 
//+------------------------------------------------------------------+
//| START Check Second Trade Mode3                                   |
//+------------------------------------------------------------------+

void Mode3_MoveSL_Trade_3()
{
 int err = 0, total = OrdersTotal(), history = HistoryTotal();
 bool ChangeStopLoss = false;

for(int z = history - 1; z >= 0; z --)
   {
   if(!OrderSelect( z,SELECT_BY_POS,MODE_HISTORY))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() == MAGICMA03) break;
   
   if(OrderMagicNumber() == MAGICMA01) break;
 
   if(OrderMagicNumber() != MAGICMA02) continue;

   if(OrderProfit() > 0) 
      {
      for(int y = total - 1; y >= 0; y --)
         {
         if(!OrderSelect(y,SELECT_BY_POS))
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }

         if(OrderSymbol() != Symbol()) continue;

        if(OrderMagicNumber()==MAGICMA03)
          {               
           TradeLog = "Mode3_ThirdTrade";
           if ((OrderType()==OP_BUY)&&(OrderStopLoss() - OrderOpenPrice()< 3 * pointvalue))
                {ModifyOrder(OrderOpenPrice()+(NormalizeDouble(Mode3_TakeProfit*0.75,0)*pointvalue),OrderOpenPrice()+NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice() - OrderStopLoss() < 3 * pointvalue))
                {ModifyOrder(OrderOpenPrice()-(NormalizeDouble(Mode3_TakeProfit*0.75,0)*pointvalue),OrderOpenPrice()-NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
          }                                 
}
}
}
}

//+------------------------------------------------------------------+
//| END Check Second Trade Mode 3                                    |
//+------------------------------------------------------------------+ 
 
  
//+------------------------------------------------------------------+
//| START Function Diverge                                           |
//+------------------------------------------------------------------+

double divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {
    int i;
    double maF1, maF2, maS1, maS2;

    maF2 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos + 1);
    maS2 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos + 1);

    return(maF2-maS2);
  }

//+------------------------------------------------------------------+
//| END Function Diverge                                             |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Valid Trade Time                                  |
//+------------------------------------------------------------------+

bool F_ValidTradeTime (int iHour)
   {
      if(((iHour >= TradeFrom1) && (iHour <= (TradeUntil1-1)))||((iHour>= TradeFrom2) && (iHour <= (TradeUntil2-1)))||((iHour >= TradeFrom3)&& (iHour <= (TradeUntil3-1)))||((iHour >= TradeFrom4) && (iHour <=(TradeUntil4-1))))
      {
       return (true);
      }
      else
       return (false);
   }  

//+------------------------------------------------------------------+
//| END Function Valid Trade Time                                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Check Close Trade After x Hours                            |
//+------------------------------------------------------------------+

void CheckCloseAfterHours()
{
int total = OrdersTotal();

for(int cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if(OrderType()<=OP_SELL &&
      OrderSymbol()==Symbol() &&
      OrderMagicNumber()==MAGICMA_A)
      {            
         if((CurTime()-OrderOpenTime())>(CloseAfterHours*3600))
           if(OrderType()==OP_BUY)
            {
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
            }
           if(OrderType()==OP_SELL)
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
            }            
      }
   }
}

//+------------------------------------------------------------------+
//| END Check Close Trade After x Hours                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Signals                                     |
//+------------------------------------------------------------------+

//=====================SIGNAL1========================
int CheckSignal(int Signal)
{
Signal=0;

bool BuySignal1=false, SellSignal1=false;

double HighEnvelope1 = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,Percent,MODE_UPPER,1);
double LowEnvelope1  = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,Percent,MODE_LOWER,1);
double CloseBar1     = iClose(NULL,0,1);

if(UseSignal1)
{
   if(CloseBar1 > HighEnvelope1) {SellSignal1 = true;} 
   if(CloseBar1 < LowEnvelope1)  {BuySignal1  = true;}
}
else {SellSignal1=true;BuySignal1=true;}



//=====================SIGNAL2========================

bool BuySignal2=false, SellSignal2=false;

double SMA1=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);
double SMA2=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,SMA2Bars);

if(UseSignal2)
{
   if(SMA2-SMA1>0) {BuySignal2  = true;}
   if(SMA2-SMA1<0) {SellSignal2 = true;}
}
else {SellSignal2=true;BuySignal2=true;}



//=====================SIGNAL3========================

bool BuySignal3=false, SellSignal3=false;

double OsMABar2=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,2);
double OsMABar1=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,1);

if(UseSignal3)
{
   if(OsMABar2 > OsMABar1)  {SellSignal3 = true;}
   if(OsMABar2 < OsMABar1)  {BuySignal3  = true;}
}
else {SellSignal3=true;BuySignal3=true;}


      
//=====================SIGNAL4========================  

   double diverge;
   bool BuySignal4=false,SellSignal4=false;
   
   diverge = divergence(Fast_Period, Slow_Period, Fast_Price, Slow_Price,0);

if(UseSignal4)
{
   if(diverge >= DVBuySell && diverge <= DVStayOut)
       {BuySignal4 = true;}
   if(diverge <= (DVBuySell*(-1)) && diverge >= (DVStayOut*(-1))) 
       {SellSignal4 = true;} 
}       
else {SellSignal4=true;BuySignal4=true;}


    
//=====================SIGNAL5=======================  

bool BuySignal5=false, SellSignal5=false;

if(UseSignal5)
{
   int iHour=TimeHour(TimeCurrent()+ ((  0 - ServerTimezone) * 3600));
   int ValidTradeTime = F_ValidTradeTime(iHour);
   if(ValidTradeTime==true)
    {
    BuySignal5=true;
    SellSignal5=true;
    }
}
else {SellSignal5=true;BuySignal5=true;}

if((SellSignal1==true) && (SellSignal2==true) && (SellSignal3==true) && (SellSignal4==true) && (SellSignal5==true)) return(1);  
if((BuySignal1==true) && (BuySignal2==true) && (BuySignal3==true) && (BuySignal4==true) && (BuySignal5==true)) return(2);
}

//+------------------------------------------------------------------+
//| END Function Check Signals                                       |
//+------------------------------------------------------------------+   

//+------------------------------------------------------------------+
//| START Calculate optimal lot size                                 |
//+------------------------------------------------------------------+

 double LotsOptimized()
 { 
   if (MM)
    {
      int    decimalPlaces=1;
      int    orders=HistoryTotal();
      int    losses=0;
      double a, maxLot, minLot;
      
      double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
      maxLot  = MarketInfo(Symbol(), MODE_MAXLOT );
      minLot  = MarketInfo(Symbol(), MODE_MINLOT );  
      a = (MaximumRisk * AccountFreeMargin() / 1000);
      
      if(LotStep<0.1) decimalPlaces=2;
      
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) a=NormalizeDouble(a-a*losses/DecreaseFactor,decimalPlaces);
     }      
      
      a =  MathFloor(a / LotStep) * LotStep;
      if (a > maxLot) return(maxLot);
      else if (a < minLot) return(minLot);
      else return(a);
    }    
   else return(Lots);
 }  
//+------------------------------------------------------------------+
//| END Calculate optimal lot size                                   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check TrailingStop                                |
//+------------------------------------------------------------------+
void CheckTrailingStop()
{
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;
   
   
    if(TrailingStop>=1)
     {
      int FakeProfit= 2*TakeProfit;
      //double Freeze_Level= MarketInfo(Symbol(),MODE_FREEZELEVEL); 
     
      TradeLog = "FirstTrade";  
      if(OrderType() == OP_BUY)
        {
         if(OrderStopLoss()<(OrderOpenPrice()+(TakeProfit*pointvalue)))
          {
           if(((Bid - OrderStopLoss()) > (pointvalue * (TrailingStop+TrailingStep))) && (OrderStopLoss() >= OrderOpenPrice() ))
              ModifyOrder(Bid - pointvalue * TrailingStop,OrderOpenPrice()+FakeProfit*pointvalue);
          }
         if(OrderStopLoss()>(OrderOpenPrice()+(TakeProfit*pointvalue)))
             {
              OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); 
              return(0);
             }  
        }
      
      if(OrderType() == OP_SELL)
         {
          if(OrderStopLoss()>(OrderOpenPrice()-(TakeProfit*pointvalue)))
            {
             if(((OrderStopLoss() - Ask) > pointvalue * (TrailingStop+TrailingStep)) && (OrderStopLoss() > Ask && OrderStopLoss() <= OrderOpenPrice()))
                ModifyOrder(Ask + pointvalue * TrailingStop,OrderOpenPrice()-FakeProfit*pointvalue);
            }            
         if(OrderStopLoss()>0.01 && OrderStopLoss()<(OrderOpenPrice()-(TakeProfit*pointvalue)))
             {
              OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); 
              return(0);
             }  
          }
       }
    }
}
//+------------------------------------------------------------------+
//| END Function Check TrailingStop                                  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Check BreakEven                                   |
//+------------------------------------------------------------------+

void CheckBreakEven()
{
for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;
    if(OrderMagicNumber()==MAGICMA_A && OrderSymbol()==Symbol()){
      if((OrderType() == OP_BUY && ((OrderStopLoss()+1*pointvalue) < OrderOpenPrice()))||(OrderType() == OP_SELL && ((OrderStopLoss()-1*pointvalue) > OrderOpenPrice()))||OrderStopLoss()==0)       
          {               
           TradeLog = "FirstTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+TakeProfit*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*BreakEvenAfterPips))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-TakeProfit*pointvalue);}
          }                           
        }
      }
}

//+------------------------------------------------------------------+
//|     END Function Check BreakEven                                 |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Close First Trade                                 |
//+------------------------------------------------------------------+


int CloseFirstTrade()
{
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;      
          if(OrderType()==OP_BUY)
             {
              OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
              return(0); 
             }  
          if(OrderType()==OP_SELL)
             {
              OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
              return(0); 
             }  

      }
}  
//+------------------------------------------------------------------+
//| END Function Close First Trade                                   |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Calculate Current Orders Mode 3                   |
//+------------------------------------------------------------------+
int Mode3CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(
      (OrderSymbol()==Symbol()) && 
      ((OrderMagicNumber()==MAGICMA01) ||
       (OrderMagicNumber()==MAGICMA02) || 
       (OrderMagicNumber()==MAGICMA03)))
        {
         if(OrderStopLoss()==0 && OrderTakeProfit()==0)
            {
             if (Mode3_TakeProfit>0 || Mode3_StopLoss>0)
              {
               if(OrderMagicNumber()==MAGICMA01)
               {
                TradeLog = "Mode3_FirstTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-Mode3_StopLoss*pointvalue,OrderOpenPrice()+NormalizeDouble(Mode3_TakeProfit/2,0)*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+Mode3_StopLoss*pointvalue,OrderOpenPrice()-NormalizeDouble(Mode3_TakeProfit/2,0)*pointvalue);}
               }  
               if(OrderMagicNumber()==MAGICMA02)
               {               
                TradeLog = "Mode3_SecondTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-Mode3_StopLoss*pointvalue,OrderOpenPrice()+Mode3_TakeProfit*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+Mode3_StopLoss*pointvalue,OrderOpenPrice()-Mode3_TakeProfit*pointvalue);}
               }                           
               if(OrderMagicNumber()==MAGICMA03)
               {               
                TradeLog = "Mode3_ThirdTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-Mode3_StopLoss*pointvalue,OrderOpenPrice()+NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+Mode3_StopLoss*pointvalue,OrderOpenPrice()-NormalizeDouble(Mode3_TakeProfit*1.5,0)*pointvalue);}
               }                           
              }
            }                  
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;                   
        }
     }
    return(buys+sells);
  }
//+------------------------------------------------------------------+
//| STOP Function Calculate Current Orders Mode 3                    |
//+------------------------------------------------------------------+

//----------------------- PRINT COMMENT FUNCTION
void subPrintDetails()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   
   sComment = "Phoenix EA              Copyright  2006, Hendrick" + NL;
   sComment = sComment + NL;
   sComment = sComment + "latest update 2011          updated version 5_6_03" + NL;
   sComment = sComment + "Signal 5   is now GMT timesetting" + NL;
   sComment = sComment + "check GMT time if not true ServerTimezone is wrong" + NL;
   sComment = sComment + NL;
   sComment = sComment + "Server Time:        " + TimeToStr(TimeCurrent(), TIME_SECONDS) + NL;
   sComment = sComment + "GMT Time:          " + TimeToStr((TimeCurrent()+ ((  0 - ServerTimezone) * 3600)), TIME_SECONDS) + NL; 
   sComment = sComment + "ServerTimezone = " + ServerTimezone + "(manual)" + NL;
   Comment(sComment);
}
//+------------------------------------------------------------------+      
//+------------------------------------------------------------------+
//| Start Modify Functions to add StopLoss And TakeProfit            |
//+------------------------------------------------------------------+

int Write(string str)
{
//Write log file
   int handle; 
   handle = FileOpen(filename,FILE_READ|FILE_WRITE|FILE_CSV,"/t");
   FileSeek(handle, 0, SEEK_END);      
   FileWrite(handle," Time " + TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS) + ": " + str);
   FileClose(handle);
 Print(str);
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int OrdModify(int _ticket, double _price, double _stoploss, double _takeprofit, datetime _expiration, color _color=CLR_NONE) {
//The function modify order with log
double _priceop=0;
int ticket,err,tries;
 
tries = 0;    
  if (!IsTradeContextBusy() && IsTradeAllowed()) {
  while (tries < NumberOfTries) {
   RefreshRates();
   ticket = OrderModify(_ticket,NormalizeDouble(_price,Digits),NormalizeDouble(_stoploss,Digits),NormalizeDouble(_takeprofit,Digits),_expiration,_color);
   if(ticket==0) {
    iError = GetLastError();
    Write("Error Occured : "+iError);
    Write(Symbol()+" Modify @ "+_price+" SL @ "+_stoploss+" TP @"+_takeprofit+" ticket ="+_ticket);
    tries++;
   } else {
    tries = NumberOfTries;
    Write("Order modified : "+Symbol()+" Modify @ "+_price+" SL @ "+_stoploss+" TP @"+_takeprofit+" ticket ="+_ticket);
   }
   Sleep(RetryTime*1000);
  }
  }
  err=ticket;
  return(err); 
}
 

//+------------------------------------------------------------------+
//| Modify Order                                                     |
//| Parameters:                                                      |
//|   ldStopLoss   - StopLoss Level                                  |
//|   ldTakeprofit - Takeprofit Level                                |
//+------------------------------------------------------------------+
void ModifyOrder(double ldStopLoss,double ldTakeprofit) {
  bool fm;
  PlaySound("alert.wav");
  fm=OrdModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,ldTakeprofit,0,CLR_NONE);
}
//+------------------------------------------------------------------+

